/*
	AccessLogDlg.cpp
	Luca Piergentili, 26/09/01
	lpiergentili@yahoo.com
	http://www.geocities.com/lpiergentili/
*/
#include "window.h"
#include "win32api.h"
#include "stristr.h"
#include "strings.h"
#include "stristr.h"
#include "CFileDialogEx.h"
#include "CLogDatabase.h"
#include "CLogDatabaseService.h"
#include "CUrl.h"
#include "CWildCards.h"
#include "CHtml.h"
#include "AccessLogDlg.h"
#include "resource.h"

BEGIN_MESSAGE_MAP(CAccessLogDlg,CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCANCEL,OnCancel)
	ON_BN_CLICKED(IDC_BUTTON_LOGFILE,OnButtonLogFile)
	ON_BN_CLICKED(IDC_BUTTON_LOGTABLE,OnButtonLogTable)
	ON_BN_CLICKED(IDC_BUTTON_HTML,OnButtonHtml)
	ON_BN_CLICKED(IDC_BUTTON_LOAD,OnButtonLoad)
	ON_BN_CLICKED(IDC_BUTTON_REPORT,OnButtonReport)
END_MESSAGE_MAP()

/*
	DoDataExchange()
*/
void CAccessLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX,IDC_EDIT_LOGFILE,m_strLogFile);
	DDX_Text(pDX,IDC_EDIT_LOGTABLE,m_strLogTable);
	DDX_Text(pDX,IDC_EDIT_HTML,m_strHtml);
	
	DDX_Check(pDX,IDC_CHECK_REFERERBYRATE,m_nRefererByRate);
	DDX_Check(pDX,IDC_CHECK_REFERERBYURL,m_nRefererByUrl);
	DDX_Check(pDX,IDC_CHECK_USERAGENTBYRATE,m_nUserAgentByRate);
	DDX_Check(pDX,IDC_CHECK_USERAGENTBYNAME,m_nUserAgentByName);
	DDX_Check(pDX,IDC_CHECK_GETBYRATE,m_nGetByRate);
	DDX_Check(pDX,IDC_CHECK_GETBYURL,m_nGetByUrl);

	DDX_Text(pDX,IDC_EDIT_DAY,m_strDay);
	DDX_Text(pDX,IDC_EDIT_MONTH,m_strMonth);
	DDX_Text(pDX,IDC_EDIT_YEAR,m_strYear);
	DDX_Text(pDX,IDC_EDIT_INCLUDEURLBYWILDCARDS,m_strIncludeUrlByWildcards);
	
	DDX_Text(pDX,IDC_EDIT_USERAGENT,m_strUserAgent);
	DDX_Text(pDX,IDC_EDIT_URL,m_strUrl);
	DDX_Text(pDX,IDC_EDIT_IP,m_strIp);
}

/*
	CAccessLogDlg()
*/
CAccessLogDlg::CAccessLogDlg(CWnd* pParent/*=NULL*/) : CDialog(IDD_ACCESSLOG_DIALOG,pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// imposta il pathname per il .ini
	::GetCurrentDirectory(sizeof(m_szCurrentDir)-1,m_szCurrentDir);
	m_strAccessLogIni.Format("%s\\%s",m_szCurrentDir,ACCESS_LOG".ini");

	//inizializza
	memset(m_szUrl,'\0',sizeof(m_szUrl));
	m_strLogFile = "";
	m_strLogTable = "";
	m_strHtml = "";
	m_nRecCount = 0;
	m_nTableWidth = 100;
	m_nRefererByRate = 0;
	m_nRefererByUrl = 0;
	m_nUserAgentByRate = 0;
	m_nUserAgentByName = 0;
	m_nGetByRate = 0;
	m_nGetByUrl = 0;
	m_strDay = "*";
	m_strMonth = "*";
	m_strYear = "*";
	m_strIncludeUrlByWildcards = "";
	m_strUserAgent = "";
	m_strUrl = "";
	m_strIp = "";
	
	// imposta con il contenuto del .ini
	LoadDefaults();
}

/*
	~CAccessLogDlg()
*/
CAccessLogDlg::~CAccessLogDlg()
{
	// salva nel .ini
	SaveDefaults();
}

/*
	OnPaint()
*/
void CAccessLogDlg::OnPaint(void)
{
	if(IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND,(WPARAM)dc.GetSafeHdc(),0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

/*
	OnQueryDragIcon()
*/
HCURSOR CAccessLogDlg::OnQueryDragIcon(void)
{
	return((HCURSOR)m_hIcon);
}

/*
	OnInitDialog()
*/
BOOL CAccessLogDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon,TRUE);
	SetIcon(m_hIcon,FALSE);

	UpdateData(FALSE);

	return(TRUE);
}

/*
	OnCancel()
*/
void CAccessLogDlg::OnCancel(void)
{
	UpdateData(TRUE);
	EndDialog(IDOK);
}

/*
	OnButtonLogFile()
*/
void CAccessLogDlg::OnButtonLogFile(void)
{
	// seleziona il file di log
	CFileOpenDialog dlg("Open Log File...",
					".",
					"*.*",
					"All Files (*.*)|*.*||"
					);

	if(dlg.DoModal()==IDOK)
		m_strLogFile.Format("%s",dlg.GetPathName());
	else
		m_strLogFile = "";

	UpdateData(FALSE);
}

/*
	OnButtonLogTable()
*/
void CAccessLogDlg::OnButtonLogTable(void)
{
	// seleziona la tabella
	CFileOpenDialog dlg("Open Log Table...",
					".",
					"*.db",
					"Berkeley DB Files (*.db)|*.db||"
					);

	if(dlg.DoModal()==IDOK)
	{
		m_strLogTable.Format("%s",dlg.GetPathName());
		char* p = stristr(m_strLogTable,".db");
		if(p)
			m_strLogTable.SetAt(p-m_strLogTable,'\0');
	}
	else
		m_strLogTable = "";

	UpdateData(FALSE);
}

/*
	OnButtonHtml()
*/
void CAccessLogDlg::OnButtonHtml(void)
{
	// seleziona la tabella
	CFileOpenDialog dlg("Open HTML File...",
					".",
					"*.htm",
					"HTML Files (*.htm)|*.htm||"
					);

	if(dlg.DoModal()==IDOK)
	{
		m_strHtml.Format("%s",dlg.GetPathName());
		if(!stristr(m_strHtml,".htm"))
			m_strHtml += ".htm";
	}
	else
		m_strHtml = "";

	UpdateData(FALSE);
}

/*
	OnButtonLoad()
*/
void CAccessLogDlg::OnButtonLoad(void)
{
	UpdateData(TRUE);

	if(m_strLogFile.IsEmpty())
	{
		AfxMessageBox("Must select a log file first.",MB_ICONWARNING);
		return;
	}

	char* p;
	char szTableName[_MAX_PATH+1];
	char szTablePath[_MAX_PATH+1];

	// nome della tabella vuoto, imposta con quello di default
	if(m_strLogTable.IsEmpty())
	{
		strcpyn(szTableName,ACCESS_LOG,sizeof(szTableName));
		strcpyn(szTablePath,m_szCurrentDir,sizeof(szTablePath));
		m_strLogTable.Format("%s\\%s",szTablePath,szTableName);
		UpdateData(FALSE);
	}
	else
	{
		char szBuffer[_MAX_PATH+1];

		strcpyn(szBuffer,m_strLogTable,sizeof(szBuffer));
		p = strrchr(szBuffer,'\\');
		if(p)
		{
			strcpyn(szTableName,p+1,sizeof(szTableName));
			strcpyn(szTablePath,szBuffer,sizeof(szTablePath));
			*strrchr(szTablePath,'\\') = '\0';
		}
		else
		{
			strcpyn(szTablePath,m_szCurrentDir,sizeof(szTablePath));
		}

	}

	// elimina l'estensione dal nome della tabella
	p = stristr(szTableName,".db");
	if(p)
		*p = '\0';

	// apre la tabella azzerandola
	CLogDatabaseService LogService(szTableName,szTablePath,TRUE);
	CLogTable* pLogTable = LogService.GetTable();
	pLogTable->Zap();
	m_nRecCount = 0L;

	// carica la tabella con il contenuto del file di log
	FILE* fp = fopen(m_strLogFile,"r");
	if(fp)
	{
		int i;
		char* p;
		char szBuffer[4096];
		long nTotRec = 0L;
		char szStatus[256];

		char ip[LOG_IP_LEN+1];
		char date[LOG_DATE_LEN+1];
		char get[8192];
		char code[LOG_CODE_LEN+1];
		char size[LOG_SIZE_LEN+1];
		char referer[LOG_REFERER_LEN+1];
		char useragent[LOG_USERAGENT_LEN+1];

		char* months[12] = {
			"Jan",
			"Feb",
			"Mar",
			"Apr",
			"May",
			"Jun",
			"Jul",
			"Aug",
			"Sep",
			"Oct",
			"Nov",
			"Dec"
		};

		char year[16];
		char month[16];
		char day[16];
		char time[24];

		// interfaccia utente
		DisableGui();
		SetWindowText("loading...");

		memset(szBuffer,'\0',sizeof(szBuffer));
		
		// legge dal file di log caricando i records
		while(fgets(szBuffer,sizeof(szBuffer)-1,fp))
		{
			p = szBuffer;

			// indirizzo ip
			i = 0;
			memset(ip,'\0',sizeof(ip));
			while(*p && *p!=' ' && i < sizeof(ip)-1)
				ip[i++] = *p++;
			
			while(*p && *p!='[')
				p++;

			p++;

			// data accesso
			i = 0;
			memset(date,'\0',sizeof(date));
			while(*p && *p!=']' && i < sizeof(date)-1)
				date[i++] = *p++;
			
			while(*p && *p!='"')
				p++;

			p++;

			// url richiesta
			i = 0;
			memset(get,'\0',sizeof(get));
			while(*p && *p!='"' && i < sizeof(get)-1)
				get[i++] = *p++;
			
			while(*p && (*p==' ' || *p=='"'))
				p++;

			// codice http
			i = 0;
			memset(code,'\0',sizeof(code));
			while(*p && isdigit(*p) && i < sizeof(code)-1)
				code[i++] = *p++;
			
			while(*p && *p==' ')
				p++;

			// dimensione dell'oggetto richiesto
			i = 0;
			memset(size,'\0',sizeof(size));
			while(*p && isdigit(*p) && i < sizeof(size)-1)
				size[i++] = *p++;
			
			while(*p && *p!='"')
				p++;

			p++;

			// url di provenienza
			i = 0;
			memset(referer,'\0',sizeof(referer));
			while(*p && *p!='"' && i < sizeof(referer)-1)
				referer[i++] = *p++;
			
			while(*p && (*p==' ' || *p=='"'))
				p++;

			// user agent
			i = 0;
			memset(useragent,'\0',sizeof(useragent));
			while(*p && *p!='"' && i < sizeof(useragent)-1)
				useragent[i++] = *p++;

			// normalizza i campi estratti dal record del file di log per l'inserimento nella tabella
			p = date;
			
			i = 0;
			memset(day,'\0',sizeof(day));
			while(*p && isdigit(*p) && i < sizeof(day)-1)
				day[i++] = *p++;
			
			while(*p && !isalpha(*p))
				p++;
			
			i = 0;
			memset(month,'\0',sizeof(month));
			while(*p && isalpha(*p) && i < sizeof(month)-1)
				month[i++] = *p++;

			int n = 0;
			for(i = 0; i < ARRAY_SIZE(months); i++)
				if(stricmp(month,months[i])==0)
				{
					n = i+1;
					break;
				}
			if(n > 0)
				_snprintf(month,sizeof(month)-1,"%.2d",n);
			else
				strcpyn(month,"00",sizeof(month));
			
			while(*p && !isdigit(*p))
				p++;
			
			i = 0;
			memset(year,'\0',sizeof(year));
			while(*p && isdigit(*p) && i < sizeof(year)-1)
				year[i++] = *p++;
			
			p++;
			
			i = 0;
			memset(time,'\0',sizeof(time));
			while(*p && i < sizeof(time)-1)
			{
				if(*p!=':' && *p!=' ')
					time[i++] = *p;
				p++;
			}

			_snprintf(date,sizeof(date)-1,"%s%s%s%s",year,month,day,time);
			
			char url[8192];

			p = get;

			memset(url,'\0',sizeof(url));
			while(*p && !isspace(*p))
				p++;
			p++;
			i = 0;
			while(*p && !isspace(*p) && i < sizeof(url)-1)
				url[i++] = *p++;

			// inserisce il record nella tabella
			if(LogService.Insert(ip,date,url,atoi(code),atol(size),referer,useragent))
			{
				m_nRecCount++;
				_snprintf(szStatus,sizeof(szStatus)-1,"adding record #%ld",++nTotRec);
				SetWindowText(szStatus);
			}

			// interfaccia utente	
			::PeekAndPump();
			
			memset(szBuffer,'\0',sizeof(szBuffer));
		}

		fclose(fp);
		
		// interfaccia utente	
		EnableGui();
		CString strMessage;
		strMessage.Format("%s\t\nhas been loaded successful (%ld records inserted).",m_strLogFile,nTotRec);
		AfxMessageBox(strMessage,MB_ICONINFORMATION);
	}
	
	SetWindowText(ACCESS_LOG);
}

/*
	OnButtonReport()
*/
void CAccessLogDlg::OnButtonReport(void)
{
	int n;
	long nTot = 0L;
	long nTotal = 0L;
	long nRecCount = 0L;
	char szKey[1024];
	char szRate[32];
	char szStartDate[32];
	char szEndDate[32];
	char* p;
	char szTableName[_MAX_PATH+1];
	char szTablePath[_MAX_PATH+1];
	char szBuffer[8192];
	CHtml html;
	BOOL bReport = FALSE;
	char* months[12] = {
		"Jan",
		"Feb",
		"Mar",
		"Apr",
		"May",
		"Jun",
		"Jul",
		"Aug",
		"Sep",
		"Oct",
		"Nov",
		"Dec"
	};

	UpdateData(TRUE);

	// controlla i campi data
	int nNumber;
	if(strcmp(m_strDay,"*")!=0)
	{
		nNumber = atoi(m_strDay);
		if(nNumber < 0 || nNumber > 31)
		{
			AfxMessageBox("Invalid day number specified.",MB_ICONWARNING);
			return;
		}
	}
	if(strcmp(m_strMonth,"*")!=0)
	{
		nNumber = atoi(m_strMonth);
		if(nNumber < 0 || nNumber > 12)
		{
			AfxMessageBox("Invalid month number specified.",MB_ICONWARNING);
			return;
		}
	}
	if(strcmp(m_strYear,"*")!=0)
	{
		nNumber = atoi(m_strYear);
		if(nNumber < 0 || nNumber > 2045)
		{
			AfxMessageBox("Invalid year number specified.",MB_ICONWARNING);
			return;
		}
	}

	// carica le liste per i tipi file da includere
	int i;
	char* pToken;
	WILDCARD* w;

	strcpyn(szBuffer,m_strIncludeUrlByWildcards,sizeof(szBuffer));
	m_IncludeUrlByWildcardsList.DeleteAll();

	for(i = 0,pToken = strtok(szBuffer,","); pToken!=NULL; i++)
	{
		w = new WILDCARD;
		strcpyn(w->wildcard,pToken,_MAX_PATH+1);
		m_IncludeUrlByWildcardsList.Add(w);
		pToken = strtok(NULL,",");
	}

	// ricava/imposta il nome della tabella
	if(m_strLogTable.IsEmpty())
	{
		AfxMessageBox("Must select a table first.",MB_ICONWARNING);
		return;
	}

	strcpyn(szBuffer,m_strLogTable,sizeof(szBuffer));
	p = strrchr(szBuffer,'\\');
	if(p)
	{
		strcpyn(szTableName,p+1,sizeof(szTableName));
		strcpyn(szTablePath,szBuffer,sizeof(szTablePath));
		*strrchr(szTablePath,'\\') = '\0';
	}
	else
	{
		strcpyn(szTablePath,m_szCurrentDir,sizeof(szTablePath));
	}

	// elimina l'estensione dal nome della tabella
	p = stristr(szTableName,".db");
	if(p)
		*p = '\0';
	
	// nome file di output per il file HTML
	if(m_strHtml.IsEmpty())
	{
		m_strHtml.Format("%s\\%s.htm",szTablePath,ACCESS_LOG);
		UpdateData(FALSE);
	}

	// interfaccia utente
	DisableGui();
	SetWindowText("loading...");
	::PeekAndPump();

	// inizializza le tabelle
	CReportDatabaseService ReportService("Report",szTablePath,TRUE);
	CReportTable* pReportTable = ReportService.GetTable();
	
	CLogDatabaseService LogService(szTableName,szTablePath,TRUE);
	CLogTable* pLogTable = LogService.GetTable();

	// totali
	SetWindowText("counting records...");
	::PeekAndPump();
	nRecCount = m_nRecCount;
	if(nRecCount <= 0)
		nRecCount = m_nRecCount = LogService.Count();

	// imposta il layout per il report
	HTMLLAYOUT htmllayout;
	htmllayout.font.type  = "verdana";
	htmllayout.font.size  = 1;
	htmllayout.font.color = NULL;
	htmllayout.align      = HTMLALIGN_NONE;
	htmllayout.style      = HTMLSTYLE_NONE;
	htmllayout.border     = 0;
	htmllayout.width      = 0;

	HTMLTABLELAYOUT htmltablelayout;
	memcpy(&(htmltablelayout.htmllayout),&htmllayout,sizeof(HTMLLAYOUT));
	htmltablelayout.title       = NULL;
	htmltablelayout.border      = 1;
	htmltablelayout.cellpadding = 1;
	htmltablelayout.cellspacing = 1;
	htmltablelayout.width       = m_nTableWidth;

	// crea il file html per il report
	if(!html.Open(m_strHtml))
	{
		AfxMessageBox("Unable to create the HTML report.",MB_ICONWARNING);
		return;
	}
	
	// titolo
	char szMeta[512];
	_snprintf(szMeta,sizeof(szMeta)-1,"<meta name=\"generator\" content=\"%s\">","AccessLog");
	html.Header("AccessLog","<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 3.2//EN\">",szMeta);

	// intestazione
	_snprintf(szBuffer,
			sizeof(szBuffer)-1,
			"<font face=\"verdana\" size=\"1\"><b>&nbsp;%s</b></font><br>",
			m_szUrl
			);
	html.Text(szBuffer);

	pLogTable->SetIndex(LOG_IDX_DATE);
	
	pLogTable->GoTop();
	pLogTable->ScatterMemvars();
	strcpyn(szStartDate,pLogTable->GetField_Date(),sizeof(szStartDate));
	CDateTime startDate(szStartDate,ANSI_SHORT);

	pLogTable->GoBottom();
	pLogTable->ScatterMemvars();
	strcpyn(szEndDate,pLogTable->GetField_Date(),sizeof(szEndDate));
	CDateTime endDate(szEndDate,ANSI_SHORT);

	startDate.SetDateFormat(BRITISH);
	_snprintf(szBuffer,
			sizeof(szBuffer)-1,
			"<font face=\"verdana\" size=\"1\"><b>&nbsp;start: %s</b></font><br>",
			startDate.GetFormattedDate(FALSE)
			);
	html.Text(szBuffer);

	endDate.SetDateFormat(BRITISH);
	_snprintf(szBuffer,
			sizeof(szBuffer)-1,
			"<font face=\"verdana\" size=\"1\"><b>&nbsp;end: %s</b></font><br>",
			endDate.GetFormattedDate(FALSE)
			);
	html.Text(szBuffer);

	_snprintf(szBuffer,
			sizeof(szBuffer)-1,
			"<font face=\"verdana\" size=\"1\"><b>&nbsp;hits: %ld</b></font><br>",
			nRecCount
			);
	html.Text(szBuffer);

	// Referer
	if(m_nRefererByRate || m_nRefererByUrl)
	{
		SetWindowText("referer...");
		::PeekAndPump();

		pReportTable->Zap();

		nTot = nTotal = 0L;
		
		pLogTable->SetIndex(LOG_IDX_REFERER);
		if(pLogTable->GoTop())
		{
			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_Referer(),sizeof(szKey));

			while(!pLogTable->Eof())
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					continue;
				}
				
				strcpyn(szBuffer,pLogTable->GetField_Referer(),sizeof(szBuffer));

				if(strcmp(szKey,pLogTable->GetField_Referer())==0)
				{
					nTot++;
				}
				else
				{
					nTotal += nTot;
					ReportService.Insert(nTot,nRecCount,szKey);
					
					nTot = 1;
					strcpyn(szKey,pLogTable->GetField_Referer(),sizeof(szKey));
				}

				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
			}
		}

		for(n = 0; n < 2; n++)
		{	
			if(n==0)
				bReport = m_nRefererByRate;
			else
				bReport = m_nRefererByUrl;

			if(bReport)
			{
				_snprintf(szBuffer,sizeof(szBuffer)-1,"<br><font face=\"verdana\" size=\"1\"><b>&nbsp;Referer by %s</b></font><br>",n==0 ? "rate" : "url");
				html.Text(szBuffer);

				// apre la tabella
				html.TableOpen(&htmltablelayout);
				
				// genera le intestazioni per le colonne
				html.TableOpenRow();
				htmllayout.style = HTMLSTYLE_BOLD;
				htmllayout.width = 0;
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Tot",&htmllayout);
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Rate (%)",&htmllayout);
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Referer",&htmllayout);
				html.TableCloseRow();
				htmllayout.style = HTMLSTYLE_NORMAL;

				// inserisce le righe della tabella
				pReportTable->SetIndex(n==0 ? REPORT_IDX_TOT : REPORT_IDX_DATA);
				if(pReportTable->GoTop())
				{
					while(!pReportTable->Eof())
					{
						::PeekAndPump();

						pReportTable->ScatterMemvars();

						html.TableOpenRow();
							
						_snprintf(szBuffer,sizeof(szBuffer)-1,"&nbsp;%ld",pReportTable->GetField_Tot());
						htmllayout.style = HTMLSTYLE_BOLD;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);
						
						_snprintf(szRate,sizeof(szRate)-1,"&nbsp;%0.5f%%",pReportTable->GetField_Rate());
						p = strchr(szRate,'.');
						if(p)
						{
							p++;
							while(*p && *p=='0')
							{
								p++;
							}
							if(*p && *(p+1))
								*(p+1) = '\0';
						}

						_snprintf(szBuffer,sizeof(szBuffer)-1,"&nbsp;%s",szRate);
						htmllayout.style = HTMLSTYLE_NORMAL;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);

						_snprintf(szBuffer,sizeof(szBuffer)-1,"%s",pReportTable->GetField_Data());
						if(strempty(szBuffer))
							strcpyn(szBuffer,"&nbsp;",sizeof(szBuffer));
						htmllayout.style = HTMLSTYLE_NORMAL;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);
							
						html.TableCloseRow();

						pReportTable->GetNext();
					}
				}

				// chiude la tabella
				html.TableClose();
			}
		}
		
		html.NewLine();
	}
	// End Referer

	// User Agent
	if(m_nUserAgentByRate || m_nUserAgentByName)
	{
		SetWindowText("user agent...");
		::PeekAndPump();

		pReportTable->Zap();

		nTot = nTotal = 0L;
		
		pLogTable->SetIndex(LOG_IDX_USERAGENT);
		if(pLogTable->GoTop())
		{
			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));

			while(!pLogTable->Eof())
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					continue;
				}
				
				strcpyn(szBuffer,pLogTable->GetField_UserAgent(),sizeof(szBuffer));

				if(strcmp(szKey,pLogTable->GetField_UserAgent())==0)
				{
					nTot++;
				}
				else
				{
					nTotal += nTot;
					ReportService.Insert(nTot,nRecCount,szKey);
					
					nTot = 1;
					strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));
				}

				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
			}
		}

		for(n = 0; n < 2; n++)
		{	
			if(n==0)
				bReport = m_nUserAgentByRate;
			else
				bReport = m_nUserAgentByName;

			if(bReport)
			{
				_snprintf(szBuffer,sizeof(szBuffer)-1,"<br><font face=\"verdana\" size=\"1\"><b>&nbsp;User Agent by %s</b></font><br>",n==0 ? "rate" : "name");
				html.Text(szBuffer);

				// apre la tabella
				html.TableOpen(&htmltablelayout);
				
				// genera le intestazioni per le colonne
				html.TableOpenRow();
				htmllayout.style = HTMLSTYLE_BOLD;
				htmllayout.width = 0;
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Tot",&htmllayout);
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Rate (%)",&htmllayout);
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;User Agent",&htmllayout);
				html.TableCloseRow();
				htmllayout.style = HTMLSTYLE_NORMAL;

				// inserisce le righe della tabella
				pReportTable->SetIndex(n==0 ? REPORT_IDX_TOT : REPORT_IDX_DATA);
				if(pReportTable->GoTop())
				{
					while(!pReportTable->Eof())
					{
						::PeekAndPump();

						pReportTable->ScatterMemvars();

						html.TableOpenRow();
							
						_snprintf(szBuffer,sizeof(szBuffer)-1,"&nbsp;%ld",pReportTable->GetField_Tot());
						htmllayout.style = HTMLSTYLE_BOLD;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);
						
						_snprintf(szRate,sizeof(szRate)-1,"&nbsp;%0.5f%%",pReportTable->GetField_Rate());
						p = strchr(szRate,'.');
						if(p)
						{
							p++;
							while(*p && *p=='0')
							{
								p++;
							}
							if(*p && *(p+1))
								*(p+1) = '\0';
						}

						_snprintf(szBuffer,sizeof(szBuffer)-1,"&nbsp;%s",szRate);
						htmllayout.style = HTMLSTYLE_NORMAL;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);

						_snprintf(szBuffer,sizeof(szBuffer)-1,"%s",pReportTable->GetField_Data());
						if(strempty(szBuffer))
							strcpyn(szBuffer,"&nbsp;",sizeof(szBuffer));
						htmllayout.style = HTMLSTYLE_NORMAL;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);
							
						html.TableCloseRow();

						pReportTable->GetNext();
					}
				}

				// chiude la tabella
				html.TableClose();
			}
		}
		
		html.NewLine();
	}
	// End User Agent

	// Url
	if(m_nGetByRate || m_nGetByUrl)
	{
		SetWindowText("get...");
		::PeekAndPump();

		pReportTable->Zap();

		nTot = nTotal = 0L;
		
		pLogTable->SetIndex(LOG_IDX_GET);
		if(pLogTable->GoTop())
		{
			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));

			while(!pLogTable->Eof())
			{
				::PeekAndPump();

				strcpyn(szBuffer,pLogTable->GetField_Get(),sizeof(szBuffer));

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					continue;
				}
				
				if(strcmp(szKey,pLogTable->GetField_Get())==0)
				{
					nTot++;
				}
				else
				{
					nTotal += nTot;
					ReportService.Insert(nTot,nRecCount,szKey);
					
					nTot = 1;
					strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));
				}

				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
			}
		}

		for(n = 0; n < 2; n++)
		{	
			if(n==0)
				bReport = m_nGetByRate;
			else
				bReport = m_nGetByUrl;

			if(bReport)
			{
				_snprintf(szBuffer,sizeof(szBuffer)-1,"<br><font face=\"verdana\" size=\"1\"><b>&nbsp;Get by %s</b></font><br>",n==0 ? "rate" : "url");
				html.Text(szBuffer);

				// apre la tabella
				html.TableOpen(&htmltablelayout);
				
				// genera le intestazioni per le colonne
				html.TableOpenRow();
				htmllayout.style = HTMLSTYLE_BOLD;
				htmllayout.width = 0;
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Tot",&htmllayout);
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Rate (%)",&htmllayout);
				htmllayout.align = HTMLALIGN_LEFT;
				html.TablePutCol("&nbsp;Get",&htmllayout);
				html.TableCloseRow();
				htmllayout.style = HTMLSTYLE_NORMAL;

				// inserisce le righe della tabella
				pReportTable->SetIndex(n==0 ? REPORT_IDX_TOT : REPORT_IDX_DATA);
				if(pReportTable->GoTop())
				{
					while(!pReportTable->Eof())
					{
						::PeekAndPump();

						pReportTable->ScatterMemvars();

						html.TableOpenRow();
							
						_snprintf(szBuffer,sizeof(szBuffer)-1,"&nbsp;%ld",pReportTable->GetField_Tot());
						htmllayout.style = HTMLSTYLE_BOLD;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);
						
						_snprintf(szRate,sizeof(szRate)-1,"&nbsp;%0.5f%%",pReportTable->GetField_Rate());
						p = strchr(szRate,'.');
						if(p)
						{
							p++;
							while(*p && *p=='0')
							{
								p++;
							}
							if(*p && *(p+1))
								*(p+1) = '\0';
						}

						_snprintf(szBuffer,sizeof(szBuffer)-1,"&nbsp;%s",szRate);
						htmllayout.style = HTMLSTYLE_NORMAL;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);

						_snprintf(szBuffer,sizeof(szBuffer)-1,"%s",pReportTable->GetField_Data());
						if(strempty(szBuffer))
							strcpyn(szBuffer,"&nbsp;",sizeof(szBuffer));
						htmllayout.style = HTMLSTYLE_NORMAL;
						htmllayout.align = HTMLALIGN_LEFT;
						html.TablePutCol(szBuffer,&htmllayout);
							
						html.TableCloseRow();

						pReportTable->GetNext();
					}
				}

				// chiude la tabella
				html.TableClose();
			}
		}
		
		html.NewLine();
	}
	// End Url

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// User Agent
	if(!m_strUserAgent.IsEmpty())
	{
		CWildCards Wildcards;
		BOOL bUserAgentExactly = FALSE;
		BOOL bUserAgentWildcards = FALSE;
		BOOL bUserAgentSimilar = FALSE;
		nTot = nTotal = 0L;

		SetWindowText("user agent...");
		::PeekAndPump();

		pReportTable->Zap();
		pLogTable->SetIndex(LOG_IDX_USERAGENT);
		pLogTable->GoTop();

		if(pLogTable->Seek(m_strUserAgent))
		{
			bUserAgentExactly = TRUE;

			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));

			while(!pLogTable->Eof() && stricmp(szKey,m_strUserAgent)==0)
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));
					continue;
				}

				_snprintf(szBuffer,
						sizeof(szBuffer)-1,
						"%s%s%s%s",
						pLogTable->GetField_Ip(),
						pLogTable->GetField_Get(),
						pLogTable->GetField_Date(),
						pLogTable->GetField_UserAgent()
						);

				if(pReportTable->LockTable())
				{
					pReportTable->ResetMemvars();
					pReportTable->PutField_Data(szBuffer);
					pReportTable->PutField_Date(pLogTable->GetField_Date());
					pReportTable->GatherMemvars();
					pReportTable->Insert();
					pReportTable->UnlockTable();
					nTot++;
				}

				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
				strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));
			}
		}
		else
		{
			BOOL bFound = FALSE;

			if(strchr(m_strUserAgent,'*') || strchr(m_strUserAgent,'?'))
				bUserAgentWildcards = TRUE;
			else
				bUserAgentSimilar = TRUE;

			if(!bUserAgentWildcards)
				if(AfxMessageBox("There is no record with the specified user agent. Would you like to search for the most similar ?",MB_ICONQUESTION|MB_YESNO)==IDNO)
					goto useragent_done;

			pLogTable->GoTop();
			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));

			while(!pLogTable->Eof())
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));
					continue;
				}

				if(bUserAgentWildcards)
					bFound = Wildcards.Match(m_strUserAgent,szKey);
				else
					bFound = stristr(szKey,m_strUserAgent)!=NULL;

				if(bFound)
				{
					_snprintf(szBuffer,
							sizeof(szBuffer)-1,
							"%s%s%s%s",
							pLogTable->GetField_Ip(),
							pLogTable->GetField_Get(),
							pLogTable->GetField_Date(),
							pLogTable->GetField_UserAgent()
							);

					if(pReportTable->LockTable())
					{
						pReportTable->ResetMemvars();
						pReportTable->PutField_Data(szBuffer);
						pReportTable->PutField_Date(pLogTable->GetField_Date());
						pReportTable->GatherMemvars();
						pReportTable->Insert();
						pReportTable->UnlockTable();
						nTot++;
					}
				}
				
				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
				strcpyn(szKey,pLogTable->GetField_UserAgent(),sizeof(szKey));
			}
		}

useragent_done:

		char* pUserAgentMode = "exactly";
		if(bUserAgentExactly)
			pUserAgentMode = "exactly";
		else if(bUserAgentWildcards)
			pUserAgentMode = "by wildcards";
		else if(bUserAgentSimilar)
			pUserAgentMode = "most similar";

		_snprintf(szBuffer,sizeof(szBuffer)-1,"<br><font face=\"verdana\" size=\"1\"><b>&nbsp;User Agent (%s): %s</b></font><br>",pUserAgentMode,m_strUserAgent);
		html.Text(szBuffer);

		// apre la tabella
		html.TableOpen(&htmltablelayout);
		
		// genera le intestazioni per le colonne
		html.TableOpenRow();
		htmllayout.style = HTMLSTYLE_BOLD;
		htmllayout.width = 0;
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Ip",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Url",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Date",&htmllayout);
		if(bUserAgentWildcards || bUserAgentSimilar)
		{
			htmllayout.align = HTMLALIGN_LEFT;
			html.TablePutCol("&nbsp;User Agent",&htmllayout);
		}
		html.TableCloseRow();
		htmllayout.style = HTMLSTYLE_NORMAL;

		// inserisce le righe della tabella
		pReportTable->SetIndex(REPORT_IDX_DATE);
		if(pReportTable->GoTop())
		{
			while(!pReportTable->Eof())
			{
				::PeekAndPump();

				pReportTable->ScatterMemvars();
				_snprintf(szBuffer,sizeof(szBuffer)-1,"%s",pReportTable->GetField_Data());

				html.TableOpenRow();

				int i;
				char* pToken;
				LOGDATE date;
				char szDate[48];
				int nTotCols = (bUserAgentWildcards || bUserAgentSimilar) ? 4 : 3;
				for(i = 0,pToken = strtok(szBuffer,""); i < nTotCols && pToken!=NULL; i++)
				{
					htmllayout.style = HTMLSTYLE_NORMAL;
					htmllayout.align = HTMLALIGN_LEFT;
					
					if(i==2)
					{
						ParseDate(pToken,&date);
						_snprintf(szDate,sizeof(szDate)-1,"%s/%s/%s %s",date.day,date.month,date.year,date.time);
						html.TablePutCol(szDate,&htmllayout);
					}
					else
						html.TablePutCol(pToken,&htmllayout);
					
					pToken = strtok(NULL,"");
				}
				

				html.TableCloseRow();

				pReportTable->GetNext();
			}
		}

		// chiude la tabella
		html.TableClose();
		_snprintf(szBuffer,sizeof(szBuffer)-1,"<font face=\"verdana\" size=\"1\"><b>&nbsp;Tot: %ld</b></font><br>",nTot);
		html.Text(szBuffer);
		
		html.NewLine();
	}
	// End User Agent

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// Url
	if(!m_strUrl.IsEmpty())
	{
		CWildCards Wildcards;
		BOOL bUrlExactly = FALSE;
		BOOL bUrlWildcards = FALSE;
		BOOL bUrlSimilar = FALSE;
		nTot = nTotal = 0L;

		SetWindowText("url...");
		::PeekAndPump();

		pReportTable->Zap();
		pLogTable->SetIndex(LOG_IDX_GET);
		pLogTable->GoTop();

		if(pLogTable->Seek(m_strUrl))
		{
			bUrlExactly = TRUE;

			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));

			while(!pLogTable->Eof() && stricmp(szKey,m_strUrl)==0)
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));
					continue;
				}

				_snprintf(szBuffer,
						sizeof(szBuffer)-1,
						"%s%s%s%s%s",
						pLogTable->GetField_Ip(),
						pLogTable->GetField_Date(),
						pLogTable->GetField_UserAgent(),
						pLogTable->GetField_Referer(),
						pLogTable->GetField_Get()
						);

				if(pReportTable->LockTable())
				{
					pReportTable->ResetMemvars();
					pReportTable->PutField_Data(szBuffer);
					pReportTable->PutField_Date(pLogTable->GetField_Date());
					pReportTable->GatherMemvars();
					pReportTable->Insert();
					pReportTable->UnlockTable();
					nTot++;
				}

				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
				strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));
			}
		}
		else
		{
			BOOL bFound = FALSE;

			if(strchr(m_strUrl,'*') || strchr(m_strUrl,'?'))
				bUrlWildcards = TRUE;
			else
				bUrlSimilar = TRUE;

			if(!bUrlWildcards)
				if(AfxMessageBox("There is no record with the specified url. Would you like to search for the most similar ?",MB_ICONQUESTION|MB_YESNO)==IDNO)
					goto url_done;

			pLogTable->GoTop();
			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));

			while(!pLogTable->Eof())
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));
					continue;
				}

				if(bUrlWildcards)
					bFound = Wildcards.Match(m_strUrl,szKey);
				else
					bFound = stristr(szKey,m_strUrl)!=NULL;

				if(bFound)
				{
					_snprintf(szBuffer,
							sizeof(szBuffer)-1,
							"%s%s%s%s%s",
							pLogTable->GetField_Ip(),
							pLogTable->GetField_Date(),
							pLogTable->GetField_UserAgent(),
							pLogTable->GetField_Referer(),
							pLogTable->GetField_Get()
							);

					if(pReportTable->LockTable())
					{
						pReportTable->ResetMemvars();
						pReportTable->PutField_Data(szBuffer);
						pReportTable->PutField_Date(pLogTable->GetField_Date());
						pReportTable->GatherMemvars();
						pReportTable->Insert();
						pReportTable->UnlockTable();
						nTot++;
					}
				}
				
				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
				strcpyn(szKey,pLogTable->GetField_Get(),sizeof(szKey));
			}
		}

url_done:

		char* pUrlMode = "exactly";
		if(bUrlExactly)
			pUrlMode = "exactly";
		else if(bUrlWildcards)
			pUrlMode = "by wildcards";
		else if(bUrlSimilar)
			pUrlMode = "most similar";

		_snprintf(szBuffer,sizeof(szBuffer)-1,"<br><font face=\"verdana\" size=\"1\"><b>&nbsp;Url (%s): %s</b></font><br>",pUrlMode,m_strUrl);
		html.Text(szBuffer);

		// apre la tabella
		html.TableOpen(&htmltablelayout);
		
		// genera le intestazioni per le colonne
		html.TableOpenRow();
		htmllayout.style = HTMLSTYLE_BOLD;
		htmllayout.width = 0;
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Ip",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Date",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;User Agent",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Referer",&htmllayout);
		if(bUrlWildcards || bUrlSimilar)
		{
			htmllayout.align = HTMLALIGN_LEFT;
			html.TablePutCol("&nbsp;Url",&htmllayout);
		}
		html.TableCloseRow();
		htmllayout.style = HTMLSTYLE_NORMAL;

		char szDateKey[48];
		LOGDATE key_date;
		LOGDATE current_date;
		int nDays = 0;
		CString strHits = "";

		// inserisce le righe della tabella
		pReportTable->SetIndex(REPORT_IDX_DATE);
		if(pReportTable->GoTop())
		{
			pReportTable->ScatterMemvars();
			strcpyn(szDateKey,pReportTable->GetField_Date(),sizeof(szDateKey));
			ParseDate(szDateKey,&key_date);

			while(!pReportTable->Eof())
			{
				::PeekAndPump();

				pReportTable->ScatterMemvars();
				ParseDate(pReportTable->GetField_Date(),&current_date);
				if(strcmp(key_date.day,current_date.day)!=0)
				{
					html.TableOpenRow();
					html.TablePutCol("&nbsp;",&htmllayout);
					int n = atoi(key_date.month)-1;
					n = (n < 0 || n > 11) ? 0 : n;
					_snprintf(szBuffer,sizeof(szBuffer)-1,"<b>%s %s %s, %ld hits</b>",key_date.day,months[n] ,key_date.year,nDays);
					html.TablePutCol(szBuffer,&htmllayout);
					_snprintf(szBuffer,sizeof(szBuffer)-1,"%s %s %s: %ld<br>\r\n",key_date.day,months[n] ,key_date.year,nDays);
					strHits += szBuffer;
					html.TablePutCol("&nbsp;",&htmllayout);
					html.TablePutCol("&nbsp;",&htmllayout);
					if(bUrlWildcards || bUrlSimilar)
						html.TablePutCol("&nbsp;",&htmllayout);
					html.TableCloseRow();
					strcpyn(szDateKey,pReportTable->GetField_Date(),sizeof(szDateKey));
					ParseDate(szDateKey,&key_date);
					nDays = 0;
				}

				nDays++;

				_snprintf(szBuffer,sizeof(szBuffer)-1,"%s",pReportTable->GetField_Data());

				html.TableOpenRow();

				int i;
				char* pToken;
				LOGDATE date;
				char szDate[48];
				int nTotCols = (bUrlWildcards || bUrlSimilar) ? 5 : 4;
				for(i = 0,pToken = strtok(szBuffer,""); i < nTotCols && pToken!=NULL; i++)
				{
					htmllayout.style = HTMLSTYLE_NORMAL;
					htmllayout.align = HTMLALIGN_LEFT;
					
					if(i==1)
					{
						ParseDate(pToken,&date);
						_snprintf(szDate,sizeof(szDate)-1,"%s/%s/%s %s",date.day,date.month,date.year,date.time);
						html.TablePutCol(szDate,&htmllayout);
					}
					else
						html.TablePutCol(pToken,&htmllayout);
					
					pToken = strtok(NULL,"");
				}
				

				html.TableCloseRow();

				pReportTable->GetNext();
			}

			if(nDays > 0)
			{
				html.TableOpenRow();
				html.TablePutCol("&nbsp;",&htmllayout);
				int n = atoi(key_date.month)-1;
				n = (n < 0 || n > 11) ? 0 : n;
				_snprintf(szBuffer,sizeof(szBuffer)-1,"<b>%s %s %s, %ld hits</b>",key_date.day,months[n] ,key_date.year,nDays);
				html.TablePutCol(szBuffer,&htmllayout);
				_snprintf(szBuffer,sizeof(szBuffer)-1,"%s %s %s: %ld<br>\r\n",key_date.day,months[n] ,key_date.year,nDays);
				strHits += szBuffer;
				html.TablePutCol("&nbsp;",&htmllayout);
				html.TablePutCol("&nbsp;",&htmllayout);
				if(bUrlWildcards || bUrlSimilar)
					html.TablePutCol("&nbsp;",&htmllayout);
				html.TableCloseRow();
			}
		}

		// chiude la tabella
		html.TableClose();
		_snprintf(szBuffer,sizeof(szBuffer)-1,"<font face=\"verdana\" size=\"1\"><br><b>%s</b><br></font>",strHits);
		html.Text(szBuffer);
		_snprintf(szBuffer,sizeof(szBuffer)-1,"<font face=\"verdana\" size=\"1\"><b>Tot: %ld</b></font><br>",nTot);
		html.Text(szBuffer);
		html.NewLine();
	}
	// End Url

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// IP
	if(!m_strIp.IsEmpty())
	{
		CWildCards Wildcards;
		BOOL bIpExactly = FALSE;
		BOOL bIpWildcards = FALSE;
		BOOL bIpSimilar = FALSE;
		nTot = nTotal = 0L;

		SetWindowText("ip...");
		::PeekAndPump();

		pReportTable->Zap();
		pLogTable->SetIndex(LOG_IDX_IP);
		pLogTable->GoTop();

		if(pLogTable->Seek(m_strIp))
		{
			bIpExactly = TRUE;

			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_Ip(),sizeof(szKey));

			while(!pLogTable->Eof() && stricmp(szKey,m_strIp)==0)
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					strcpyn(szKey,pLogTable->GetField_Ip(),sizeof(szKey));
					continue;
				}

				_snprintf(szBuffer,
						sizeof(szBuffer)-1,
						"%s%s%s%s%s",
						pLogTable->GetField_Ip(),
						pLogTable->GetField_Date(),
						pLogTable->GetField_UserAgent(),
						pLogTable->GetField_Referer(),
						pLogTable->GetField_Get()
						);

				if(pReportTable->LockTable())
				{
					pReportTable->ResetMemvars();
					pReportTable->PutField_Data(szBuffer);
					pReportTable->PutField_Date(pLogTable->GetField_Date());
					pReportTable->GatherMemvars();
					pReportTable->Insert();
					pReportTable->UnlockTable();
					nTot++;
				}

				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
				strcpyn(szKey,pLogTable->GetField_Ip(),sizeof(szKey));
			}
		}
		else
		{
			BOOL bFound = FALSE;

			if(strchr(m_strIp,'*') || strchr(m_strIp,'?'))
				bIpWildcards = TRUE;
			else
				bIpSimilar = TRUE;

			if(!bIpWildcards)
				if(AfxMessageBox("There is no record with the specified ip address. Would you like to search for the most similar ?",MB_ICONQUESTION|MB_YESNO)==IDNO)
					goto ip_done;

			pLogTable->GoTop();
			pLogTable->ScatterMemvars();
			strcpyn(szKey,pLogTable->GetField_Ip(),sizeof(szKey));

			while(!pLogTable->Eof())
			{
				::PeekAndPump();

				if(!MatchFilters(pLogTable->GetField_Get(),pLogTable->GetField_Date()))
				{
					pLogTable->GetNext();
					pLogTable->ScatterMemvars();
					strcpyn(szKey,pLogTable->GetField_Ip(),sizeof(szKey));
					continue;
				}

				if(bIpWildcards)
					bFound = Wildcards.Match(m_strIp,szKey);
				else
					bFound = stristr(szKey,m_strIp)!=NULL;

				if(bFound)
				{
					_snprintf(szBuffer,
							sizeof(szBuffer)-1,
							"%s%s%s%s%s",
							pLogTable->GetField_Ip(),
							pLogTable->GetField_Date(),
							pLogTable->GetField_UserAgent(),
							pLogTable->GetField_Referer(),
							pLogTable->GetField_Get()
							);

					if(pReportTable->LockTable())
					{
						pReportTable->ResetMemvars();
						pReportTable->PutField_Data(szBuffer);
						pReportTable->PutField_Date(pLogTable->GetField_Date());
						pReportTable->GatherMemvars();
						pReportTable->Insert();
						pReportTable->UnlockTable();
						nTot++;
					}
				}
				
				pLogTable->GetNext();
				pLogTable->ScatterMemvars();
				strcpyn(szKey,pLogTable->GetField_Ip(),sizeof(szKey));
			}
		}

ip_done:

		char* pIpMode = "exactly";
		if(bIpExactly)
			pIpMode = "exactly";
		else if(bIpWildcards)
			pIpMode = "by wildcards";
		else if(bIpSimilar)
			pIpMode = "most similar";

		_snprintf(szBuffer,sizeof(szBuffer)-1,"<br><font face=\"verdana\" size=\"1\"><b>&nbsp;IP (%s): %s</b></font><br>",pIpMode,m_strIp);
		html.Text(szBuffer);

		// apre la tabella
		html.TableOpen(&htmltablelayout);
		
		// genera le intestazioni per le colonne
		html.TableOpenRow();
		htmllayout.style = HTMLSTYLE_BOLD;
		htmllayout.width = 0;
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Ip",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Date",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;User Agent",&htmllayout);
		htmllayout.align = HTMLALIGN_LEFT;
		html.TablePutCol("&nbsp;Referer",&htmllayout);
		if(bIpWildcards || bIpSimilar)
		{
			htmllayout.align = HTMLALIGN_LEFT;
			html.TablePutCol("&nbsp;Url",&htmllayout);
		}
		html.TableCloseRow();
		htmllayout.style = HTMLSTYLE_NORMAL;

		char szIpKey[256];
		int nHits = 0;

		// inserisce le righe della tabella
		pReportTable->SetIndex(REPORT_IDX_DATA);
		if(pReportTable->GoTop())
		{
			pReportTable->ScatterMemvars();
			strcpyn(szKey,pReportTable->GetField_Data(),sizeof(szKey));
			if((p = strchr(szKey,''))!=NULL)
				*p = '\0';

			while(!pReportTable->Eof())
			{
				::PeekAndPump();

				pReportTable->ScatterMemvars();
				strcpyn(szIpKey,pReportTable->GetField_Data(),sizeof(szIpKey));
				if((p = strchr(szIpKey,''))!=NULL)
					*p = '\0';
				
				if(strcmp(szKey,szIpKey)!=0)
				{
					html.TableOpenRow();
					html.TablePutCol("&nbsp;",&htmllayout);
					_snprintf(szBuffer,sizeof(szBuffer)-1,"<b>%ld hits</b>",nHits);
					html.TablePutCol(szBuffer,&htmllayout);
					html.TablePutCol("&nbsp;",&htmllayout);
					html.TablePutCol("&nbsp;",&htmllayout);
					if(bIpWildcards || bIpSimilar)
						html.TablePutCol("&nbsp;",&htmllayout);
					html.TableCloseRow();
					strcpyn(szKey,pReportTable->GetField_Data(),sizeof(szKey));
					if((p = strchr(szKey,''))!=NULL)
						*p = '\0';
					nHits = 0;
				}
				
				nHits++;

				_snprintf(szBuffer,sizeof(szBuffer)-1,"%s",pReportTable->GetField_Data());

				html.TableOpenRow();

				int i;
				char* pToken;
				LOGDATE date;
				char szDate[48];
				int nTotCols = (bIpWildcards || bIpSimilar) ? 5 : 4;
				for(i = 0,pToken = strtok(szBuffer,""); i < nTotCols && pToken!=NULL; i++)
				{
					htmllayout.style = HTMLSTYLE_NORMAL;
					htmllayout.align = HTMLALIGN_LEFT;
					
					if(i==1)
					{
						ParseDate(pToken,&date);
						_snprintf(szDate,sizeof(szDate)-1,"%s/%s/%s %s",date.day,date.month,date.year,date.time);
						html.TablePutCol(szDate,&htmllayout);
					}
					else
						html.TablePutCol(pToken,&htmllayout);
					
					pToken = strtok(NULL,"");
				}
				

				html.TableCloseRow();

				pReportTable->GetNext();
			}

			if(nHits > 0)
			{
				html.TableOpenRow();
				html.TablePutCol("&nbsp;",&htmllayout);
				_snprintf(szBuffer,sizeof(szBuffer)-1,"<b>%ld hits</b>",nHits);
				html.TablePutCol(szBuffer,&htmllayout);
				html.TablePutCol("&nbsp;",&htmllayout);
				html.TablePutCol("&nbsp;",&htmllayout);
				if(bIpWildcards || bIpSimilar)
					html.TablePutCol("&nbsp;",&htmllayout);
				html.TableCloseRow();
			}
		}

		// chiude la tabella
		html.TableClose();
		_snprintf(szBuffer,sizeof(szBuffer)-1,"<font face=\"verdana\" size=\"1\"><b>Tot: %ld</b></font><br>",nTot);
		html.Text(szBuffer);
		html.NewLine();
	}
	// End IP

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// interfaccia utente
	EnableGui();
	SetWindowText(ACCESS_LOG);

	AfxMessageBox("Done.",MB_ICONINFORMATION);
}

/*
	LoadDefaults()
*/
void CAccessLogDlg::LoadDefaults(void)
{
	// carica i defaults dal .ini
	char szBuffer[8192];
	memset(szBuffer,'\0',sizeof(szBuffer));

	::GetPrivateProfileString("Site","Url","<none>",m_szUrl,sizeof(m_szUrl)-1,m_strAccessLogIni);

	if(::GetPrivateProfileString("PathNames","LogFile","",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni) > 0L)
		m_strLogFile.Format("%s",szBuffer);
	else
		m_strLogFile = "";
	if(::GetPrivateProfileString("PathNames","LogTable","",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni) > 0L)
		m_strLogTable.Format("%s",szBuffer);
	else
		m_strLogTable = "";
	if(::GetPrivateProfileString("PathNames","HtmlReport","",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni) > 0L)
		m_strHtml.Format("%s",szBuffer);
	else
		m_strHtml = "";
	m_nRecCount = ::GetPrivateProfileInt("Database","RecCount",0,m_strAccessLogIni);
	
	m_nTableWidth = ::GetPrivateProfileInt("Report","TableWidth",100,m_strAccessLogIni);
	m_nRefererByRate = ::GetPrivateProfileInt("Report","RefererByRate",1,m_strAccessLogIni);
	m_nRefererByUrl = ::GetPrivateProfileInt("Report","RefererByUrl",1,m_strAccessLogIni);
	m_nUserAgentByRate = ::GetPrivateProfileInt("Report","UserAgentByRate",1,m_strAccessLogIni);
	m_nUserAgentByName = ::GetPrivateProfileInt("Report","UserAgentByName",1,m_strAccessLogIni);
	m_nGetByRate = ::GetPrivateProfileInt("Report","GetByRate",1,m_strAccessLogIni);
	m_nGetByUrl = ::GetPrivateProfileInt("Report","GetByUrl",1,m_strAccessLogIni);

	::GetPrivateProfileString("Report","Day","*",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni);
	m_strDay.Format("%s",szBuffer);
	::GetPrivateProfileString("Report","Month","*",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni);
	m_strMonth.Format("%s",szBuffer);
	::GetPrivateProfileString("Report","Year","*",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni);
	m_strYear.Format("%s",szBuffer);

	int i;
	char* pToken;
	WILDCARD* w;

	::GetPrivateProfileString("Report","IncludeUrlByWildcards","",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni);
	m_strIncludeUrlByWildcards.Format("%s",szBuffer);

	for(i = 0,pToken = strtok(szBuffer,","); pToken!=NULL; i++)
	{
		w = new WILDCARD;
		strcpyn(w->wildcard,pToken,_MAX_PATH+1);
		m_IncludeUrlByWildcardsList.Add(w);
		pToken = strtok(NULL,",");
	}

	::GetPrivateProfileString("Report","UserAgent","",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni);
	m_strUserAgent.Format("%s",szBuffer);
	::GetPrivateProfileString("Report","Url","",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni);
	m_strUrl.Format("%s",szBuffer);
	::GetPrivateProfileString("Report","IP","",szBuffer,sizeof(szBuffer)-1,m_strAccessLogIni);
	m_strIp.Format("%s",szBuffer);
}

/*
	SaveDefaults()
*/
void CAccessLogDlg::SaveDefaults(void)
{
	// salva la configurazione corrente nel .ini
	::WritePrivateProfileString("PathNames","LogFile",m_strLogFile,m_strAccessLogIni);
	::WritePrivateProfileString("PathNames","LogTable",m_strLogTable,m_strAccessLogIni);
	::WritePrivateProfileString("PathNames","HtmlReport",m_strHtml,m_strAccessLogIni);
	::WritePrivateProfileInt("Database","RecCount",m_nRecCount,m_strAccessLogIni);

	::WritePrivateProfileInt("Report","TableWidth",m_nTableWidth,m_strAccessLogIni);
	::WritePrivateProfileInt("Report","RefererByRate",m_nRefererByRate,m_strAccessLogIni);
	::WritePrivateProfileInt("Report","RefererByUrl",m_nRefererByUrl,m_strAccessLogIni);
	::WritePrivateProfileInt("Report","UserAgentByRate",m_nUserAgentByRate,m_strAccessLogIni);
	::WritePrivateProfileInt("Report","UserAgentByName",m_nUserAgentByName,m_strAccessLogIni);
	::WritePrivateProfileInt("Report","GetByRate",m_nGetByRate,m_strAccessLogIni);
	::WritePrivateProfileInt("Report","GetByUrl",m_nGetByUrl,m_strAccessLogIni);

	::WritePrivateProfileString("Report","Day",m_strDay,m_strAccessLogIni);
	::WritePrivateProfileString("Report","Month",m_strMonth,m_strAccessLogIni);
	::WritePrivateProfileString("Report","Year",m_strYear,m_strAccessLogIni);

	::WritePrivateProfileString("Report","IncludeUrlByWildcards",m_strIncludeUrlByWildcards,m_strAccessLogIni);

	::WritePrivateProfileString("Report","UserAgent",m_strUserAgent,m_strAccessLogIni);
	::WritePrivateProfileString("Report","Url",m_strUrl,m_strAccessLogIni);
	::WritePrivateProfileString("Report","IP",m_strIp,m_strAccessLogIni);
}

/*
	FindWildcards()
*/
BOOL CAccessLogDlg::FindWildcards(LPCSTR lpcszString,CWildcardList* pWildcardList)
{
	BOOL bFound = FALSE;
	ITERATOR iter;
	CWildCards Wildcards;
	WILDCARD* w;
	
	// confronta la stringa con quanto presente nella lista
	if((iter = pWildcardList->First())!=(ITERATOR)NULL)
		while(iter!=(ITERATOR)NULL)
		{
			w = (WILDCARD*)iter->data;
			if(w)
			{
				if(Wildcards.Match(w->wildcard,(LPSTR)lpcszString))
				{
					bFound = TRUE;
					break;
				}
			}
			
			iter = pWildcardList->Next(iter);
		}

	return(bFound);
}

/*
	ParseDate()
*/
void CAccessLogDlg::ParseDate(LPCSTR lpcszDate,LOGDATE* date)
{
	memset(date,'\0',sizeof(LOGDATE));
	memcpy(date->day,lpcszDate+6,2);
	memcpy(date->month,lpcszDate+4,2);
	memcpy(date->year,lpcszDate,4);
	sprintf(date->time,"%c%c:%c%c:%c%c",lpcszDate[8],lpcszDate[9],lpcszDate[10],lpcszDate[11],lpcszDate[12],lpcszDate[13]);
}

/*
	MatchFilters()
*/
BOOL CAccessLogDlg::MatchFilters(LPCSTR lpcszGet,LPCSTR lpcszDate)
{
	BOOL bMatch = TRUE;

	if(bMatch)
	{
		LOGDATE date;

		if(bMatch)
			if(strcmp(m_strDay,"*")!=0)
			{
				ParseDate(lpcszDate,&date);
				if(strcmp(date.day,m_strDay)!=0)
					bMatch = FALSE;
			}
		if(bMatch)
			if(strcmp(m_strMonth,"*")!=0)
			{
				ParseDate(lpcszDate,&date);
				if(strcmp(date.month,m_strMonth)!=0)
					bMatch = FALSE;
			}
		if(bMatch)
			if(strcmp(m_strYear,"*")!=0)
			{
				ParseDate(lpcszDate,&date);
				if(strcmp(date.year,m_strYear)!=0)
					bMatch = FALSE;
			}
	}

	if(bMatch)
	{
		if(m_IncludeUrlByWildcardsList.Count() > 0)
			bMatch = FindWildcards(lpcszGet,&m_IncludeUrlByWildcardsList);
	}

	return(bMatch);
}

/*
	EnableGui()
*/
void CAccessLogDlg::EnableGui(void)
{
	GetDlgItem(IDC_EDIT_LOGFILE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_LOGTABLE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_HTML)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_BUTTON_LOGFILE)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_LOGTABLE)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_HTML)->EnableWindow(TRUE);

	GetDlgItem(IDC_CHECK_REFERERBYRATE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_REFERERBYURL)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_USERAGENTBYRATE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_USERAGENTBYNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_GETBYRATE)->EnableWindow(TRUE);
	GetDlgItem(IDC_CHECK_GETBYURL)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_EDIT_DAY)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_MONTH)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_YEAR)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_INCLUDEURLBYWILDCARDS)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_USERAGENT)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_URL)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_IP)->EnableWindow(TRUE);

	GetDlgItem(IDC_BUTTON_LOAD)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_REPORT)->EnableWindow(TRUE);
}

/*
	DisableGui()
*/
void CAccessLogDlg::DisableGui(void)
{
	GetDlgItem(IDC_EDIT_LOGFILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_LOGTABLE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_HTML)->EnableWindow(FALSE);
	
	GetDlgItem(IDC_BUTTON_LOGFILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_LOGTABLE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_HTML)->EnableWindow(FALSE);

	GetDlgItem(IDC_CHECK_REFERERBYRATE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_REFERERBYURL)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_USERAGENTBYRATE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_USERAGENTBYNAME)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_GETBYRATE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_GETBYURL)->EnableWindow(FALSE);
	
	GetDlgItem(IDC_EDIT_DAY)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_MONTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_YEAR)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_INCLUDEURLBYWILDCARDS)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_USERAGENT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_URL)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_IP)->EnableWindow(FALSE);

	GetDlgItem(IDC_BUTTON_LOAD)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_REPORT)->EnableWindow(FALSE);
}
