/*
	CMutexEx.cpp
	Classe derivata per la gestione dei mutex (MFC).
	Luca Piergentili, 06/07/98
	lpiergentili@yahoo.com
	http://www.geocities.com/lpiergentili/
*/
#include "env.h"
#include "pragma.h"
#include "strcpyn.h"
#include "window.h"
#include "CMutexEx.h"

/*
	CMutexEx()
*/
CMutexEx::CMutexEx(LPCSTR lpszName/*=NULL*/,BOOL bInitiallyOwn/*=FALSE*/,LPSECURITY_ATTRIBUTES lpsaAttribute/*=NULL*/) : CMutex(bInitiallyOwn,lpszName,lpsaAttribute)
{
	m_nTimeout = MUTEX_LOCK_TIMEOUT;

	if(lpszName)
		strcpyn(m_szMutexName,lpszName,sizeof(m_szMutexName));
	else
		strcpyn(m_szMutexName,"anonymous",sizeof(m_szMutexName));
}

/*
	LockEx()
*/
BOOL CMutexEx::LockEx(UINT timeout)
{
	BOOL bLocked = TRUE;
	DWORD dwRet = ::WaitForSingleObject(GetHandle(),(DWORD)timeout * 1000L);

	if(dwRet==WAIT_FAILED || dwRet==WAIT_ABANDONED || dwRet==WAIT_TIMEOUT)
		bLocked = FALSE;

	return(bLocked);
}
