/*
	AccessLogDlg.h
	Luca Piergentili, 26/09/01
	lpiergentili@yahoo.com
	http://www.geocities.com/lpiergentili/
*/
#ifndef _ACCESSLOGDLG_H
#define _ACCESSLOGDLG_H 1

#include "window.h"
#include "CNodeList.h"
#include "CWildCards.h"
#include "CUrl.h"

#define ACCESS_LOG "AccessLog"

struct WILDCARD {
	char	wildcard[_MAX_PATH+1];
};

class CWildcardList : public CNodeList
{
public:
	CWildcardList() {}
	virtual ~CWildcardList() {CNodeList::DeleteAll();}
	BOOL PreDelete(ITERATOR iter)
	{
		delete ((WILDCARD*)iter->data);
		iter->data = (WILDCARD*)NULL;
		return(TRUE);
	}
	int Size(void) {return(sizeof(WILDCARD));}
#ifdef _DEBUG
	const char* Signature(void) {return("CWildcardList");}
#endif
};

struct LOGDATE {
	char day[3];
	char month[3];
	char year[5];
	char time[9];
};

class CAccessLogDlg : public CDialog
{
public:
	CAccessLogDlg(CWnd* pParent = NULL);
	~CAccessLogDlg();

private:
	void			DoDataExchange		(CDataExchange* pDX);
	void			OnPaint			(void);
	HCURSOR		OnQueryDragIcon	(void);
	BOOL			OnInitDialog		(void);
	
	void			OnCancel			(void);
	void			OnButtonLogFile	(void);
	void			OnButtonLogTable	(void);
	void			OnButtonHtml		(void);
	void			OnButtonLoad		(void);
	void			OnButtonReport		(void);

	void			LoadDefaults		(void);
	void			SaveDefaults		(void);

	BOOL			FindWildcards		(LPCSTR lpcszString,CWildcardList* pWildcardList);
	void			ParseDate			(LPCSTR lpcszDate,LOGDATE* date);
	BOOL			MatchFilters		(LPCSTR lpcszGet,LPCSTR lpcszDate);

	void			EnableGui			(void);
	void			DisableGui		(void);

	HICON		m_hIcon;
	char			m_szCurrentDir[_MAX_PATH+1];
	CString		m_strAccessLogIni;
	
	char			m_szUrl[MAX_URL+1];

	CString		m_strLogFile;
	CString		m_strLogTable;
	CString		m_strHtml;
	long			m_nRecCount;
		
	int			m_nTableWidth;
	int			m_nRefererByRate;
	int			m_nRefererByUrl;
	int			m_nUserAgentByRate;
	int			m_nUserAgentByName;
	int			m_nGetByRate;
	int			m_nGetByUrl;

	CString		m_strDay;
	CString		m_strMonth;
	CString		m_strYear;

	CString		m_strIncludeUrlByWildcards;
	CWildcardList	m_IncludeUrlByWildcardsList;

	CString		m_strUserAgent;
	CString		m_strUrl;
	CString		m_strIp;
	
	DECLARE_MESSAGE_MAP()
};

#endif // _ACCESSLOGDLG_H
