/*
	CWildCards.h
	Classe base per gestione wildcards (?*).
	Modifiche minori al codice originale di Florian Schintke (vedi sotto).
	Luca Piergentili, 26/06/00
	lpiergentili@yahoo.com
	http://www.geocities.com/lpiergentili/

	Implementation of the UN*X wildcards in C. So they are available in a portable way and can be used
	whereever	needed.
	Author(s):
	Florian Schintke (schintke@cs.tu-berlin.de)
	Dates:
	First editing: unknown, but before 04/02/1997
	Last Change  : 11/10/1998
*/
#ifndef _CWILDCARDS_H
#define _CWILDCARDS_H 1

//#include "window.h"

class CWildCards
{
public:
	CWildCards() {}
	virtual ~CWildCards() {}

	// 0 if wildcard does not match test
	// 1 if wildcard matches test
	int Match(const char* wildcards,const char* test);

private:
	// scans a set of characters and returns 0 if the set mismatches at this
	// position in the teststring and 1 if it is matching wildcard is set to
	// the closing ] and test is unmodified if mismatched and otherwise the
	// char pointer is pointing to the next character
	int set(const char** wildcard,const char** test);

	// scans an asterisk
	int asterisk(const char** wildcard,const char** test);
};

#endif // _CWILDCARDS_H
